﻿using System;
using System.Collections.Generic;
using Cars.Engines;
using Cars;
namespace Cars
{
    class PersonalCar
    {
        private String manufacturer;
        private Engine engine;
        private String registration;
        private int seats;
        public PersonalCar(String manufacturer, Engine engine, String registration,int seats)
        {
            this.engine = engine;
            this.registration = registration;
            this.manufacturer = manufacturer;
            this.seats = seats;
        }

        public Engine GetEngine()
        {
            return engine;
        }

        public String GetRegistration()
        {
            return registration;
        }

        public String GetManufacturer()
        {
            return manufacturer;
        }

        public int GetSeats()
        {
            return seats;
        }

        override public String ToString()
        {
            return manufacturer + "(" + seats +"), engine: " + engine + ", registration: " + registration;
        }
    }
    
    class Truck
    {
        private int maxLoad;
        private String manufacturer, registration;
        private Engine engine;

        public Truck(String manufacturer, String registration, int maxLoad, Engine engine)
        {
            this.manufacturer = manufacturer;
            this.registration = registration;
            this.maxLoad = maxLoad;
            this.engine = engine;
        }

        override public String ToString()
        {
            return manufacturer + ": registration: " + registration + ", maximal load: " + maxLoad + ", " + engine;
        }

    }

    namespace Engines
    {
        class Engine
        {
            private int power;
            private String manufacturer;
            

            public Engine(String manufacturer, int power)
            {
                this.power = power;
                this.manufacturer = manufacturer;
                
            }

            public int GetPower()
            {
                return power;
            }

            public String GetManufacturer()
            {
                return manufacturer;
            }

            

            override public String ToString() 
            {
                return manufacturer + "(" + power + " HP)";
            }
        }
    }

        

}

namespace Demo
{
    class Demo
    {
        public static void Main(String[] args)
        {
            Engine pCarEngine = new Engine("Skoda",45);
            Engine truckEngine = new Engine("DAF",500);
            PersonalCar car1 = new PersonalCar("Skoda",pCarEngine,"1A2345",5);
            Truck truck1 = new Truck("Volvo", "1B2345", 5000, truckEngine);

            Console.WriteLine("Personal car: " + car1);
            Console.WriteLine("Truck :" + truck1);
            Console.ReadLine();
        }
    }
}